-- ###################################################################
-- ## Module: @(#)02-orders_rr.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create Partition by Round Robin 

drop table if exists orders_rr;

create table orders_rr 
  (
    order_num serial not null ,
    order_date date,
    customer_num integer not null ,
    ship_instruct char(40),
    backlog char(1),
    po_num char(10),
    ship_date date,
    ship_weight decimal(8,2),
    ship_charge money(6,2),
    paid_date date
  )
partition by round robin in datab4adbs, datab4bdbs, datab4cdbs, datab4ddbs ;

insert into orders_rr select * from base_orders;

create unique index orders_rr_pk on orders_rr ( order_num ) in datab4adbs;

alter table orders_rr add constraint primary key ( order_num );


select count(*) from orders_rr;
select year(order_date) year, month(order_date) month,  count(*) rec_count 
from orders_rr
group by 1, 2
order by 1, 2;

select count(*) num_data_part
from sysfragments where tabid = (select tabid from systables where tabname = "orders_rr")
and fragtype = "T";

select count(*) num_index_part
from sysfragments where tabid = (select tabid from systables where tabname = "orders_rr")
and fragtype = "I";
