-- ###################################################################
-- ## Module: @(#)03-orders_exp.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create Partition by Expression

drop table if exists orders_exp;

create table orders_exp 
  (
    order_num serial not null ,
    order_date date,
    customer_num integer not null ,
    ship_instruct char(40),
    backlog char(1),
    po_num char(10),
    ship_date date,
    ship_weight decimal(8,2),
    ship_charge money(6,2),
    paid_date date
  )
partition by expression 
partition p_exp1 order_date between  "01/01/2017" and "01/31/2017"  in datab4adbs,
partition p_exp2 order_date between  "02/01/2017" and "02/28/2017"  in datab4bdbs,
partition p_exp3 order_date between  "03/01/2017" and "03/31/2017"  in datab4cdbs,
partition p_exp4 order_date between  "04/01/2017" and "04/30/2017"  in datab4ddbs,

partition p_exp5 order_date between  "05/01/2017" and "05/31/2017"  in datab4adbs,
partition p_exp6 order_date between  "06/01/2017" and "06/30/2017"  in datab4bdbs,
partition p_exp7 order_date between  "07/01/2017" and "07/31/2017"  in datab4cdbs,
partition p_exp8 order_date between  "08/01/2017" and "08/31/2017"  in datab4ddbs,

partition p_exp9 order_date between  "09/01/2017" and "09/30/2017"  in datab4adbs,
partition p_exp10 order_date between  "10/01/2017" and "10/31/2017"  in datab4bdbs,
partition p_exp11 order_date between  "11/01/2017" and "11/30/2017"  in datab4cdbs,
partition p_exp12 order_date between  "12/01/2017" and "12/31/2017"  in datab4ddbs,

partition p_exp13 order_date between  "01/01/2018" and "01/31/2018"  in datab4adbs,
partition p_exp14 order_date between  "02/01/2018" and "02/28/2018"  in datab4bdbs,
partition p_exp15 order_date between  "03/01/2018" and "03/31/2018"  in datab4cdbs,
partition p_exp16 order_date between  "04/01/2018" and "04/30/2018"  in datab4ddbs
;


insert into orders_exp select * from base_orders;

create unique index orders_exp_pk on orders_exp ( order_num ) in datab4adbs;

alter table orders_exp add constraint primary key ( order_num );


select count(*) from orders_exp;
select year(order_date) year, month(order_date) month,  count(*) rec_count 
from orders_exp
group by 1, 2
order by 1, 2;


select count(*) num_data_part
from sysfragments where tabid = (select tabid from systables where tabname = "orders_exp")
and fragtype = "T";

select count(*) num_index_part
from sysfragments where tabid = (select tabid from systables where tabname = "orders_exp")
and fragtype = "I";
