-- ###################################################################
-- ## Module: @(#)06-orders_rolling.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create Rolling Windows Partition by Range Interval with Index Partitioned

drop table if exists orders_rolling ;

create table orders_rolling 
  (
    order_num serial not null ,
    order_date date,
    customer_num integer not null ,
    ship_instruct char(40),
    backlog char(1),
    po_num char(10),
    ship_date date,
    ship_weight decimal(8,2),
    ship_charge money(6,2),
    paid_date date
  )
partition by range (order_date) interval ( NUMTOYMINTERVAL ( 1,"MONTH"))
rolling ( 4 fragments ) detach
store in ( datab4adbs, datab4bdbs, datab4cdbs, datab4ddbs )
partition p1 values < date ( "01/01/2017" )  in datadbs
;


insert into orders_rolling select * from base_orders;

create unique index orders_rolling_pk on orders_rolling ( order_num, order_date ) ;
-- partition by range (order_date) interval ( NUMTOYMINTERVAL ( 1,"MONTH"))
-- rolling ( 4 fragments ) detach
-- store in ( datab4adbs, datab4bdbs, datab4cdbs, datab4ddbs )
-- partition p1 values < date ( "01/01/2012" )  in datadbs;

-- alter table orders_rolling add constraint primary key ( order_num, order_date );

select count(*) from orders_rolling;
select year(order_date) year, month(order_date) month,  count(*) rec_count 
from orders_rolling
group by 1, 2
order by 1, 2;

select count(*) num_data_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_rolling") 
and fragtype = "T";

select count(*) num_index_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_rolling") 
and fragtype = "I";
