-- ###################################################################
-- ## Module: @(#)07-orders_serial.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create Serial Number Rollowing Windows Partition by Range Interval with Index Partitioned

drop table if exists orders_serial;

create table orders_serial 
  (
    order_num serial not null ,
    order_date date,
    customer_num integer not null ,
    ship_instruct char(40),
    backlog char(1),
    po_num char(10),
    ship_date date,
    ship_weight decimal(8,2),
    ship_charge money(6,2),
    paid_date date
  )
partition by range (order_num) interval (1000) 
rolling ( 100 fragments ) detach
store in ( datab4adbs, datab4bdbs, datab4cdbs, datab4ddbs )
partition p1 values < 0  in datadbs
;


insert into orders_serial select * from base_orders;

create unique index orders_serial_pk on orders_serial ( order_num ) ;

alter table orders_serial add constraint primary key ( order_num );

select count(*) from orders_serial;
select year(order_date) year, month(order_date) month,  count(*) rec_count 
from orders_serial
group by 1, 2
order by 1, 2;

select count(*) num_data_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_serial") 
and fragtype = "T";

select count(*) num_index_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_serial") 
and fragtype = "I";
