-- ###################################################################
-- ## Module: @(#)07-show_partition.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create Serial Number Rollowing Windows Partition by Range Interval with Index Partitioned
update statistics ;

-- Count number of partations;
select t.tabname, f.fragtype, count(*) Partition_count 
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and t.tabname in ("orders_serial")
group by 1, 2
order by 1, 2; 

-- Show Table partations
select t.tabname,
        t.tabid,
        f.fragtype,
        f.exprtext[1,100],
        f.partition
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and f.fragtype = "T"
and t.tabname in ("orders_serial")
-- and t.tabname in ("test_invoice_month")
;

-- Show Index partations
select t.tabname,
        t.tabid,
        f.fragtype,
        f.exprtext[1,100],
        f.partition
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and f.fragtype = "I"
and t.tabname in ("orders_serial")
;

-- Show ALL partations
select t.tabname,
        t.tabid,
        f.*
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and t.tabname in ("orders_serial")
;
