-- ###################################################################
-- ## Module: @(#)08-mk_detach_partion.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Select partitions to detach or drop

-- Creat a temp table to cast the sysfragment.exprtext from text to character

drop table if exists tmp_partition_name;

create temp table tmp_partition_name (
        tabname         varchar(128),
        tabid           integer,
        fragtype        char(1),
        fragexpression  char(1000),
        partition       varchar(128)
        );

-- Insert the rows from sysfragments
unload to /tmp/sysfragments.uld
select t.tabname, 
        t.tabid,
        f.fragtype,
        f.exprtext[1,1000],
        f.partition
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and f.fragtype = "T"
and f.partition matches "sys*" -- System generated partition name
and t.tabname in ( "orders_interval" )
;

load from /tmp/sysfragments.uld
insert into tmp_partition_name;

unload to "detach_partition.sql" delimiter ";"
select "alter fragment on table " || trim(tabname) || " detach partition " ||
        trim(partition) || " "  || trim(tabname) || "_" || trim(partition) ,
	"-- " || trim(fragexpression)
from tmp_partition_name 
where fragexpression matches "*2017*";
-- where fragexpression matches "*02/01/2017*";

