-- ###################################################################
-- ## Module: @(#)08-orders_history.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Create History Partition by Range Interval
-- Contains Prior Year data from orders_interval

drop table if exists orders_history;

create table orders_history 
  (
    order_num serial not null ,
    order_date date,
    customer_num integer not null ,
    ship_instruct char(40),
    backlog char(1),
    po_num char(10),
    ship_date date,
    ship_weight decimal(8,2),
    ship_charge money(6,2),
    paid_date date
  )
partition by range (order_date) interval ( NUMTOYMINTERVAL ( 1,"MONTH"))
store in ( datab4adbs, datab4bdbs, datab4cdbs, datab4ddbs )
partition p1 values < date ( "01/01/2012" )  in datadbs
;


-- insert into orders_history select * from base_orders;

create unique index orders_history on orders_history ( order_num ) in datab4adbs;

alter table orders_history add constraint primary key ( order_num );


select count(*) from orders_history;
select year(order_date) year, month(order_date) month,  count(*) rec_count 
from orders_history
group by 1, 2
order by 1, 2;

select count(*) num_data_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_history") 
and fragtype = "T";

select count(*) num_index_part 
from sysfragments where tabid = (select tabid from systables where tabname = "orders_history") 
and fragtype = "I";
