-- ###################################################################
-- ## Module: @(#)show_partition.sql      2.0     Date: 06/01/2018
-- ## Author: Lester Knutsen  Email: lester@advancedatatools.com
-- ##         Advanced DataTools Corporation (c)
-- ###################################################################

-- Count number of partations;
update statistics ;

select t.tabname, f.fragtype, count(*) Partition_count 
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
group by 1, 2
order by 1, 2; 

-- Show Table partations
select t.tabname,
        t.tabid,
        f.fragtype,
        f.exprtext[1,100],
        f.partition
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and f.fragtype = "T"
;

-- Show Index partations
select t.tabname,
        t.tabid,
        f.fragtype,
        f.exprtext[1,100],
        f.partition
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
and f.fragtype = "I"
;


-- Show ALL partations
select t.tabname,
        t.tabid,
        f.*
from systables t, sysfragments f
where t.tabid = f.tabid
and t.tabid > 99
;
